<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_klarna_kco/classes/constants.php';

global $db, $language, $xtLink, $currency, $tax, $countries, $customers_status;

try
{
    // deactivate paypal express
    if(!isset($_SESSION['deppex']))
    {
        $db->Execute("UPDATE ".TABLE_CONFIGURATION_PAYMENT." SET config_value='false' WHERE config_key='XT_PAYPAL_EXPRESS'");
        $_SESSION['deppex'] = 1;
    }
    if(is_array($_SESSION['cart']->show_content) && count($_SESSION['cart']->show_content))
    {
        $errors = array();
        $return = [];

        $urls =  xt_klarna_kco::getCallbackUrls();

        if (empty($_SESSION['kco_order_id']) ||
            (!empty($_SESSION['kco_order_id'] && $_SESSION["cart"]->type == 'virtual' && $_SESSION["last_kco_cart_type"] != 'virtual'))
        )
        {
            unset($_SESSION["cart"]->sub_content['shipping']);
            unset($_SESSION["cart"]->show_sub_content['shipping']);
            unset($_SESSION["cart"]->sub_content['xt_coupon']);
            unset($_SESSION["cart"]->show_sub_content['xt_coupon']);
            $kco_order = klarna_kco::createCheckoutOrder($_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $errors, $return);
        }
        else
        {
            try
            {
                $kco_order = klarna_kco::getCheckoutOrder($_SESSION['kco_order_id']);
                if($kco_order['status'] == 'checkout_complete')
                {
                    // should not happen, but for some reason we have an completed order
                    throw new Exception('order in status completed,. creating new one');
                }
                if (
                    $_SESSION["cart"]->type != 'virtual' &&
                    (
                    !is_array($kco_order['shipping_options']) ||
                    count($kco_order['shipping_options'])==0 || $kco_order['shipping_options'][0]['id'] == 'SHIPPING_NOT_AVAILABLE'
                    )
                )
                {
                    $errors[] = array('key' => 'NO_SHIPPING_FOUND', 'shipping_country' => $_SESSION['kco_shipping_country']);
                }
            }
            catch(Exception $ex)
            {
                $kco_order = klarna_kco::createCheckoutOrder($_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $errors, $return);
            }
            /**
             * check if update needed
             */
            $kco_lang = explode('-',$kco_order['locale'])[0];
            $lang_changed = false;
            if(strtolower($language->code) != strtolower($kco_lang))
            {
                $lang_changed = true;
            }

            if(
                strtolower($currency->code) != strtolower($kco_order['purchase_currency']) ||
                $_SESSION['cart']->total['plain']*100 != $kco_order['order_amount'] ||
                $_REQUEST['coupon_code'] || array_key_exists('coupon_removed', $_REQUEST)

            )
            {
                $errors = array();

                //$csspt = (int) $db->GetOne('SELECT customers_status_show_price_tax from '.TABLE_CUSTOMERS_STATUS.' WHERE customers_status_id = ?', array($_SESSION['customer']->customers_status));

                klarna_kco::updateOrderAmounts($kco_order, $_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $_SESSION['kco_shipping_country'], $errors, $return);
            }
            else if($lang_changed)
            {
                klarna_kco::setLanguage($language->code, $kco_order);
                klarna_kco::updateLanguage($kco_order, $_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $_SESSION['kco_shipping_country'], $language->code, $errors);
            }
        }

        $kco_order_url = $kco_order->getLocation();
        $kco_order_id = $_SESSION['kco_order_id'] = $kco_order->getId();
        $_SESSION['kco_shipping_country'] = strtoupper($kco_order['shipping_address']['country']);
        $kco_shipping_country_iso3 = strtolower(klarna_kco::convert_country_code($_SESSION['kco_shipping_country']));

        $_SESSION["last_kco_cart_type"] = $_SESSION["cart"]->type;

        if(count($errors))
        {
            foreach($errors as $error)
            {
                $msg = TEXT_KLARNA_GENERAL_ERROR;
                $details = '';
                if(is_array($error))
                {
                    switch($error['key'])
                    {
                        case 'NO_SHIPPING_FOUND':
                            if($_SESSION['cart']->type != 'virtual')
                            {
                                $msg = WARNING_NO_SHIPPING_FOR_ZONE;

                                global $system_shipping_link;
                                $shipping_link = $system_shipping_link->shipping_link;
                                if ($shipping_link != '')
                                {
                                    $msg .= ' <a href="' . $shipping_link . '">' . TEXT_SHIPPING_COSTS . '</a>';
                                }
                                $details = TEXT_COUNTRY . ': ' . $error['shipping_country'] . ' &nbsp; ' . TEXT_SUB_TOTAL . ': ' . $_SESSION['cart']->content_total['formated'];
                            }
                            break;
                    }
                }
                echo'<div class="alert alert-danger klarna-error" role="alert"><p class="item"><span class="glyphicon glyphicon-exclamation-sign"></span>&nbsp;&nbsp;'.$msg.'</p><p style="font-size:0.8em">'.$details.'</p></div>';
            }
        }

        $debug = isset($_SESSION['XDEBUG_SESSION_START']) ? '&XDEBUG_SESSION_START=' . $_SESSION['XDEBUG_SESSION_START'] : '';

        if(constant('_KLARNA_CONFIG_TESTMODE') == 1)
        {
            $tplFile = 'warning-test-mode.tpl.html';
            $template = new Template();
            $template->getTemplatePath($tplFile, 'xt_klarna_kco', '', 'plugin');
            $tpl_data = array(
                'kco_order_id' => $kco_order_id
            );
            $html = $template->getTemplate('', $tplFile, $tpl_data);
            echo $html;
        }

        if(!array_key_exists('separate_shipping_country', $_SESSION))
        {
            //$separate_shipping_country = $return['separate_shipping_country'];
            $separate_shipping_country = '';
        }
        else {
            $separate_shipping_country = $_SESSION['separate_shipping_country'];
        }

        echo '
        <script>
        var kco_callback_url = "' . $urls['push'] . '&kco_order_id=' . $kco_order_id . $debug . '";
        var kco_shipping_country = "'.$kco_shipping_country_iso3.'";
        var kco_selected_shipping= "'.$_SESSION['kco_selected_shipping'].'";
        var kco_separate_shipping_country = "'.$separate_shipping_country.'";
        console.log("kco_separate_shipping_country => "+kco_separate_shipping_country);
        </script>
';
        echo '<div>' . $kco_order["html_snippet"] . '</div>';
    }
}
catch(Exception $e)
{

    // check if error because no SSL is activated
    if (strpos($e->getMessage(),'must be a valid https URI')!==false) {
        error_log($e->getMessage());
        echo'<img src="plugins/xt_klarna_kco/images/kco_no_ssl_desktop.png" style="opacity: 0.5"/>';

    } else {
        error_log($e->getMessage());
        echo'<div class="alert alert-danger" role="alert"><p class="item"><span class="glyphicon glyphicon-exclamation-sign"></span>&nbsp;&nbsp;'.TEXT_KLARNA_GENERAL_ERROR.'</p><p style="font-size:0.8em">'.$e->getMessage().'</p></div>';
    }
}

