jQuery(document).ready(function()
{
    var change_firstCall = true;
    var country_change_firstCall = true;
    var order_total_change_firstCall = true;
    var shipping_option_change_firstCall = true;
    var shipping_address_change_firstCall = true;

    if (typeof window._klarnaCheckout !== "undefined") {
        window._klarnaCheckout(function (api) {
        api.on({
            "change": function (data) {

                console.log("got event [change]", {
                    'data':data,
                    'kco_shipping_country':kco_shipping_country,
                    'kco_separate_shipping_country':kco_separate_shipping_country});
                if(!change_firstCall)
                {
                    if (data.country != "undefined" && data.country != kco_shipping_country
                        && kco_separate_shipping_country == "")
                    {
                        //console.log(data);
                        api.suspend();

                        var url = kco_callback_url + "&event=change";

                        $(".klarna-error").remove();

                        var jqxhr = $.ajax({
                            type: "POST",
                            url: url,
                            data: data,
                            dataType: "json"
                        })
                            .done(function(jqxhr) {
                                console.log( "change success", jqxhr);
                                $(".klarna-error").remove();

                                if (jqxhr.error_html != "undefined") {
                                    $("#kco-checkout").prepend($(jqxhr.error_html));
                                }
                                if(jqxhr.kco_shipping_country != window.kco_shipping_country)
                                {
                                    $("#kco_wait_modal").modal({backdrop:'static', keyboard:false});
                                    window.location.reload();
                                }
                                window.kco_shipping_country = data.country;
                                //
                            })
                            .fail(function(jqxhr, status, error) {
                                console.log( "change error", jqxhr, status, error );
                            })
                            .always(function() {

                                api.resume();
                            });
                    }
                }
                else {
                    console.log("ignoring first [change] event");
                }

                change_firstCall = false;
            },

            "shipping_address_change": function (data) {

                console.log("got event [shipping_address_change]", {
                    'data':data,
                    'kco_shipping_country':kco_shipping_country,
                    'kco_separate_shipping_country':kco_separate_shipping_country});

                if (!shipping_address_change_firstCall || true) {

                    if (data.country != "undefined" && data.country != kco_shipping_country) {
                        api.suspend();

                        var url = kco_callback_url + "&event=shipping_address_change";

                        $(".klarna-error").remove();

                        var jqxhr = $.ajax({
                            type: "POST",
                            url: url,
                            data: data,
                            dataType: "json"
                        })
                            .done(function (jqxhr) {
                                console.log("shipping_address_change success", jqxhr);
                                $(".klarna-error").remove();
                                kco_shipping_country = data.country;
                                if (jqxhr.error_html != "undefined") {
                                    $("#kco-checkout").prepend($(jqxhr.error_html));
                                }
                                window.kco_shipping_country = data.country;
                                $("#kco_wait_modal").modal({backdrop:'static', keyboard:false});
                                window.location.reload();
                            })
                            .fail(function (jqxhr, status, error) {
                                console.log("shipping_address_change error", jqxhr, status, error);
                            })
                            .always(function () {

                                api.resume();
                            });
                    }
                }
                else {
                    console.log("ignoring first [shipping_address_change] event");
                }
                shipping_address_change_firstCall = false;
            },

            "order_total_change": function(data) {
                //console.log("got event [order_total_change]", data);

                order_total_change_firstCall = false;
            },
            "shipping_option_change": function(data) {
                console.log("got event [shipping_option_change]", data);

                // siehe change event
                    if (!shipping_option_change_firstCall) {
                        if (data.id != "undefined" && data.id != kco_selected_shipping) {
                        //console.log(data);
                        api.suspend();

                        var url = kco_callback_url + "&event=shipping_option_change";

                        //$(".klarna-error").remove();

                        var jqxhr = $.ajax({
                            type: "POST",
                            url: url,
                            data: data,
                            dataType: "json"
                        })
                            .done(function(jqxhr) {
                                console.log( "shipping_option_change success", jqxhr.kco_selected_shipping);
                                $(".klarna-error").remove();
                                kco_selected_shipping = data.id;
                                    if (jqxhr.error_html != "undefined") {
                                    $("#kco-checkout").prepend($(jqxhr.error_html));
                                }

                            })
                            .fail(function(jqxhr, status, error) {
                                console.log( "shipping_option_change error", jqxhr, status, error );
                            })
                            .always(function() {

                                api.resume();
                            });
                    }

                }
                shipping_option_change_firstCall = false;

            }

        });// end on`s

    });
    }

    $("#comments").delayedKeyup(600, function()
    {
        setComments($(this).val());
    });

});

function setComments(text)
{
    var url = kco_callback_url + "&event=set_comment";

    var jqxhr = $.ajax({
        type: "POST",
        url: url,
        data: {comments: text}
    })
        .done(function() {
            console.log( "set_comment success" );
            var elem = $("#comments_saved_msg");
            elem.fadeIn("fast", function() { $(this).delay(1000).fadeOut("slow"); });
        })
        .fail(function() {
            console.log( "set_comment error" );
        })
        .always(function() {
        });
}

